/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Wed Jun 14 2000
    copyright            : (C) 2000 by Olivier ELEMENTO
    email                : olivier@ligm.igh.cnrs.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "pvm3.h"
#include <stdio.h>
#include <stdlib.h>
#include "tree.h"

//#include "memtrace.h"
#include "pvm3.h"

int main(int argc, char *argv[])
{
  //general
	FILE* fp;	
	int num, i, j, k;
	
	//pvm
	int mytid;
	int tids[32];
	int n, nproc, numt, who, msgtype, nhost, narch, bufid, master, num_sets;
  struct pvmhostinfo *hostp;

  //spec data
  char* str;
  tree* treeptr;
  int nb_trees;

  /* enroll in pvm */
  mytid = pvm_mytid();
	
	
  //recupere les donnees
  msgtype = 0;
	pvm_recv(-1, msgtype);
	pvm_upkint(&nb_species, 1, 1);
	pvm_upkint(&seq_length, 1, 1);
	pvm_upkint(&num_sets, 1, 1);
	
	
	bst_data = (char***)malloc(num_sets*sizeof(char**));
	for (i=0; i<num_sets; i++) {
		bst_data[i] = (char**)malloc(nb_species*sizeof(char*));
		for (j=0; j<nb_species; j++) {
			bst_data[i][j] =(char*)calloc(seq_length, sizeof(char));
			pvm_upkstr(bst_data[i][j]);
		}
	}
	

	//initialise les arbres prefixe
	initTreeStores(nb_species);
	
	
	master = pvm_parent();
	msgtype = 5;
	
	//go!
	for (i=0; i<num_sets; i++) {
		data = bst_data[i];
		
		initDupliTree();
		initTree(dt_root->stree, nb_species);
		reInitTreeStores(nb_species);
		buildChildren(dt_root, nb_species); 	
		
		
		//cree un buffer et met comme buffer courant
		bufid = pvm_mkbuf(PvmDataDefault);
		pvm_setsbuf(bufid);
		
		//pack la parci
  	pvm_pkint(&minpars, 1, 1);
  	
  	//compte les arbres
  	treeptr = firsttree;
  	nb_trees = 0;
  	while (treeptr != 0) {
  		nb_trees++;
  		treeptr = treeptr->next;
  	}
  	
  	//envoie le nomdre d'arbres
  	pvm_pkint(&nb_trees, 1, 1);
  	
  	//envoie le nombres de noeuds par arbres
  	pvm_pkint(&(firsttree->maxnodes), 1, 1);
  	
  	//envoie le nomdres de noeuds internes
  	pvm_pkint(&(firsttree->numintnodes), 1, 1);
  	
  	//envoie le nombre de feuilles
  	pvm_pkint(&(firsttree->numleaves), 1, 1);
  	
  	
  	//pack les arbres
  	treeptr = firsttree;
  	while (treeptr != 0) {
  		str = (char*)calloc(100, sizeof(char));
  		saveTree(treeptr, 0, str);
  		
  		//pack la representation phylip
  		pvm_pkstr(str);
  		
  		//pack les prec
  		pvm_pkint(treeptr->nodes, treeptr->maxnodes, 1);
  		
  		//pack les children
  		for (k=0; k<treeptr->maxnodes; k++) {
  			pvm_pkint(treeptr->children[k], 2, 1);
  		}
  		
  		treeptr = treeptr->next;
  	}
  	
  	//envoie le buffer avec msg 5
  	msgtype = 5;
		pvm_send( master, msgtype );
		
		//vide le buffer
		pvm_freebuf(bufid);
	}
	
  pvm_exit();

	
  return EXIT_SUCCESS;
}
